package es.ucm.fdi.grasia.faerie.examples.bottomUp.sen1;

import java.net.URI;

import org.apache.felix.scr.annotations.Component;
import org.apache.log4j.Logger;

import es.ucm.fdi.grasia.faerie.core.AbstractAttributeUpdaterComponent;
import es.ucm.fdi.grasia.faerie.core.Attribute;
import es.ucm.fdi.grasia.faerie.core.ContextEvent;
import es.ucm.fdi.grasia.faerie.core.ContextObserver;
import es.ucm.fdi.grasia.faerie.core.NotAccessibleContextException;
import es.ucm.fdi.grasia.faerie.core.model.BasicContextValue;
import es.ucm.fdi.grasia.faerie.core.util.Functions;
import es.ucm.fdi.grasia.faerie.examples.bottomUp.model.Attribute2;

@Component(inherit = true)
@SuppressWarnings({ "unchecked", "rawtypes" })
public class BottomUpEvalSen1 extends AbstractAttributeUpdaterComponent {

	private boolean finish = false;

	@Override
	public int handle(ContextEvent event) {
		return Functions.attributeInstanceOfEntityLocalIdAddedOrRemoved("/example/s1", Attribute2.class.getName(),
				event) ? ContextObserver.HANDLE_WRITE : ContextObserver.HANDLE_NONE;
	}

	@Override
	public void elementAdded(Attribute attributeInstance, ContextEvent event) {
		this.putUpdatedAttributeInstance(attributeInstance);

		final URI attributeInstanceId = attributeInstance.getId();

		finish = false;
		Thread thread = new Thread() {

			@Override
			public void run() {
				Attribute att = BottomUpEvalSen1.this.getUpdatedAttributeInstance(attributeInstanceId);
				while (!finish)
					try {
						try {
							Thread.sleep(3000);
						} catch (InterruptedException e) {
						}
						att.update(new BasicContextValue("Sensor 1", 1.0, BottomUpEvalSen1.this.getBundleEntity()));
						try {
							Thread.sleep(3000);
						} catch (InterruptedException e) {
						}
						att.update(new BasicContextValue("Sensor 1 NEXT", 1.0, BottomUpEvalSen1.this.getBundleEntity()));
						Logger.getLogger(this.getClass()).trace("finish = " + finish);
					} catch (NotAccessibleContextException ex) {
					}
			}
		};
		thread.setDaemon(true);
		thread.start();
	}

	@Override
	public void elementRemoved(Attribute attributeInstance, ContextEvent event) {
		finish = true;
		super.elementRemoved(attributeInstance, event);
	}
}
